<?php
/**
 *
 * @category        modules
 * @package         imagegallery
 * @author          Daniel Wacker, Matthias Gallas, Rob Smith, Manfred Fuenkner
 * @copyright       2004-2009, Ryan Djurovich
 * @copyright       2009-2010, Website Baker Org. e.V.
 * @link            http://www.websitebaker2.org/
 * @license         http://www.gnu.org/licenses/gpl.html
 * @platform        WebsiteBaker 2.8.x
 * @requirements    PHP 8.0.0 and higher
 *
*/

//Modulbeschreibung
$module_description = 'Mit dem Modul erzeugen sie eine Bildergalerie von einem beliebigem Bilderordner im Medienverzeichnis. Der Originalscript stammt von Daniel Wacker <daniel.wacker@web.de>.';

//Variablen für Frontend Texte
$MOD_IMAGEGALLERY['PREVIOUS'] = 'Vorheriges';
$MOD_IMAGEGALLERY['NEXT']    = 'Nächstes';
$MOD_IMAGEGALLERY['OVERVIEW']    = 'Übersicht';

//Variablen für Backend Texte
$MOD_IMAGEGALLERY['MAIN_SETTINGS'] = 'Bildergalerie Einstellungen';
$MOD_IMAGEGALLERY['TITLE'] = 'Name der Galerie';
$MOD_IMAGEGALLERY['ORIGINAL_PICS'] = 'Originalbilder';
$MOD_IMAGEGALLERY['THUMBS'] = 'Vorschaubilder';
$MOD_IMAGEGALLERY['GALLERY'] = 'Galerie';
$MOD_IMAGEGALLERY['TITLE_TEXT'] = 'Überschrift festlegen';
$MOD_IMAGEGALLERY['SHOW_TITLE'] = 'Überschrift anzeigen';
$MOD_IMAGEGALLERY['PICDIR'] = 'Media-Verzeichnis mit Originalbildern';
$MOD_IMAGEGALLERY['INCLUDE_SUBDIRS'] = 'Unterverzeichnisse einschließen';
$MOD_IMAGEGALLERY['EXCLUDE_SUBDIRS'] = 'Unterverzeichnisse ausschließen';
$MOD_IMAGEGALLERY['THUMBDIR'] = 'Name für Vorschaubildverzeichnis';
$MOD_IMAGEGALLERY['MAXPICS'] = 'Anzahl der Vorschaubilder pro Seite';
$MOD_IMAGEGALLERY['THUMBS_BACKGROUND'] = 'Hintergrund für Vorschaubilder';
$MOD_IMAGEGALLERY['TEXT_COLOR'] = 'Textfarbe für Titel und Links';
$MOD_IMAGEGALLERY['TEXT_COLOR_HOVER'] = 'Textfarbe HOVER für Links';
$MOD_IMAGEGALLERY['THUMBSIZE'] = 'Größe der Vorschaubilder';
$MOD_IMAGEGALLERY['MAXWIDTH'] = 'Maximale Breite der Bilder';
$MOD_IMAGEGALLERY['SHOW_FILE_NAMES'] = 'Dateinamen anzeigen';
$MOD_IMAGEGALLERY['SHOW_ORIGINAL'] = 'Originalbild auf neuer Seite zeigen';
$MOD_IMAGEGALLERY['SHOW_TEXTLINK'] = 'Text anstelle von Icons für vor/zurück';
$MOD_IMAGEGALLERY['INLINE'] = 'Bilder im Inhaltsbereich anzeigen';
$MOD_IMAGEGALLERY['THUMBSQUARE'] = 'Crop Methode für Vorschaubild';
$MOD_IMAGEGALLERY['THUMB_NEW'] = 'Neue Vorschaubilder erstellen!';

//Variablen für Fehlermeldungen
$MOD_IMAGEGALLERY_WORDS['error'] = 'Fehler';
$MOD_IMAGEGALLERY_WORDS['php_error'] = 'PHP Version >= 7.4.x wid benötigt.';
$MOD_IMAGEGALLERY_WORDS['gd_error'] = 'GD Library wird benötigt. Siehe https://www.boutell.com/gd/.';
$MOD_IMAGEGALLERY_WORDS['jpg_error'] = 'JPEG-Software wird ben&ouml;tigt. Siehe ftp://ftp.uu.net/graphics/jpeg/.';
$MOD_IMAGEGALLERY_WORDS['mkdir_error'] = 'Für dieses Verzeichnis wird Schreibberechtigung ben&ouml;tigt.';
$MOD_IMAGEGALLERY_WORDS['opendir_error'] = 'Das Verzeichnis "%1" kann nicht gelesen werden.';

$MOD_IMAGEGALLERY_WORDS['1'] = 'Quelldatei kann nicht gefunden werden!';
$MOD_IMAGEGALLERY_WORDS['2'] = 'Quelldatei ist nicht lesbar!';
$MOD_IMAGEGALLERY_WORDS['3'] = 'Could not write target file!';
$MOD_IMAGEGALLERY_WORDS['4'] = 'Nicht unterstütztes Dateiformat in der Quelldatei!';
$MOD_IMAGEGALLERY_WORDS['5'] = 'Nicht unterstütztes Dateiformat in der Zieldatei!';
$MOD_IMAGEGALLERY_WORDS['6'] = 'GD library version ünterstützt das gewählte Zielformat nicht!';
$MOD_IMAGEGALLERY_WORDS['7'] = 'GD library ist nicht installiert!';
$MOD_IMAGEGALLERY_WORDS['8'] = '"chmod" ist auf command-Ebene deaktiviert!';
$MOD_IMAGEGALLERY_WORDS['9'] = 'exif_read_data" -Funktion nicht verfügbar';

$MOD_IMAGE_METHODE['ZEBRA_IMAGE_BOXED'] = 0;
$MOD_IMAGE_METHODE['ZEBRA_IMAGE_NOT_BOXED'] = 1;
$MOD_IMAGE_METHODE['ZEBRA_IMAGE_CROP_TOPLEFT'] = 2;
$MOD_IMAGE_METHODE['ZEBRA_IMAGE_CROP_TOPCENTER'] = 3;
$MOD_IMAGE_METHODE['ZEBRA_IMAGE_CROP_TOPRIGHT'] = 4;
$MOD_IMAGE_METHODE['ZEBRA_IMAGE_CROP_MIDDLELEFT'] = 5;
$MOD_IMAGE_METHODE['ZEBRA_IMAGE_CROP_CENTER'] = 6;
$MOD_IMAGE_METHODE['ZEBRA_IMAGE_CROP_MIDDLERIGHT'] = 7;
$MOD_IMAGE_METHODE['ZEBRA_IMAGE_CROP_BOTTOMLEFT'] = 8;
$MOD_IMAGE_METHODE['ZEBRA_IMAGE_CROP_BOTTOMCENTER'] = 9;
$MOD_IMAGE_METHODE['ZEBRA_IMAGE_CROP_BOTTOMRIGHT'] = 10;

$MOD_LANG_METHODE[0]  = 'Bildausschnitt in Box';
$MOD_LANG_METHODE[1]  = 'Bildausschnitt nicht in Box';
$MOD_LANG_METHODE[2]  = 'Bildausschnitt oben links';
$MOD_LANG_METHODE[3]  = 'Bildausschnitt oben mittig';
$MOD_LANG_METHODE[4]  = 'Bildausschnitt oben rechts';
$MOD_LANG_METHODE[5]  = 'Bildausschnitt Mitte links';
$MOD_LANG_METHODE[6]  = 'Bildausschnitt Mitte';
$MOD_LANG_METHODE[7]  = 'Bildausschnitt Mitte rechts';
$MOD_LANG_METHODE[8]  = 'Bildausschnitt unten links';
$MOD_LANG_METHODE[9]  = 'Bildausschnitt unten mittig';
$MOD_LANG_METHODE[10] = 'Bildausschnitt unten rechts';
