<?php
/**
 *
 * @category        modules
 * @package         imagegallery
 * @author          Daniel Wacker, Matthias Gallas, Rob Smith, Manfred Fuenkner
 * @copyright       2004-2009, Ryan Djurovich
 * @copyright       2009-2010, Website Baker Org. e.V.
 * @link            http://www.websitebaker2.org/
 * @license         http://www.gnu.org/licenses/gpl.html
 * @platform        WebsiteBaker 2.8.x
 * @requirements    PHP 8.0.0 and higher
 *
*/

//Modul Description
$module_description = 'This module allows you to create a image Gallery using galerie.php - a simple gallery script from Daniel Wacker <daniel.wacker@web.de>.';

//Variablen für Frontend Texte
$MOD_IMAGEGALLERY['PREVIOUS'] = 'previous';
$MOD_IMAGEGALLERY['NEXT']    = 'next';
$MOD_IMAGEGALLERY['OVERVIEW']    = 'Overview';

//Variables for the Backend
$MOD_IMAGEGALLERY['MAIN_SETTINGS'] = 'Imagegallery Settings';
$MOD_IMAGEGALLERY['TITLE'] = 'Title';
$MOD_IMAGEGALLERY['ORIGINAL_PICS'] = 'Pictures';
$MOD_IMAGEGALLERY['THUMBS'] = 'Thumbs';
$MOD_IMAGEGALLERY['GALLERY'] = 'Gallery';
$MOD_IMAGEGALLERY['TITLE_TEXT'] = 'Define Title';
$MOD_IMAGEGALLERY['SHOW_TITLE'] = 'Show Gallery Title';
$MOD_IMAGEGALLERY['PICDIR'] = 'Dir from the pictures';
$MOD_IMAGEGALLERY['INCLUDE_SUBDIRS'] = 'Include Subdirs';
$MOD_IMAGEGALLERY['EXCLUDE_SUBDIRS'] = 'Exclude Subdirs';
$MOD_IMAGEGALLERY['THUMBDIR'] = 'Name for Thumbdir';
$MOD_IMAGEGALLERY['MAXPICS'] = 'Number of Thumbs per page';
$MOD_IMAGEGALLERY['THUMBS_BACKGROUND'] = 'Thumbs Background';
$MOD_IMAGEGALLERY['TEXT_COLOR'] = 'Title and links text color';
$MOD_IMAGEGALLERY['TEXT_COLOR_HOVER'] = 'Links text hover color';
$MOD_IMAGEGALLERY['THUMBSIZE'] = 'Thumbsize';
$MOD_IMAGEGALLERY['MAXWIDTH']    = 'Maximum Width';
$MOD_IMAGEGALLERY['SHOW_FILE_NAMES'] = 'Show Filenames';
$MOD_IMAGEGALLERY['SHOW_ORIGINAL'] = 'Show Original';
$MOD_IMAGEGALLERY['SHOW_TEXTLINK'] = 'Text next/previous links';
$MOD_IMAGEGALLERY['INLINE'] = 'Show gallery inline';
$MOD_IMAGEGALLERY['THUMBSQUARE'] = 'Crop Methode for Thumbnail';
$MOD_IMAGEGALLERY['THUMB_NEW'] = 'Create new thumbnails!';

//Variables for Error messages
$MOD_IMAGEGALLERY_WORDS['error'] = 'Error';
$MOD_IMAGEGALLERY_WORDS['php_error'] = 'PHP >= 7.4.x is required.';
$MOD_IMAGEGALLERY_WORDS['gd_error'] = 'GD Library is required. See http://www.boutell.com/gd/.';
$MOD_IMAGEGALLERY_WORDS['jpg_error'] = 'JPEG software is required. See ftp://ftp.uu.net/graphics/jpeg/.';
$MOD_IMAGEGALLERY_WORDS['mkdir_error'] = 'Write permission is required in this folder.';
$MOD_IMAGEGALLERY_WORDS['opendir_error'] = 'The directory "%1" can not be read.';

$MOD_IMAGEGALLERY_WORDS['1'] = 'Source file could not be found!';
$MOD_IMAGEGALLERY_WORDS['2'] = 'Source file is not readable!';
$MOD_IMAGEGALLERY_WORDS['3'] = 'Could not write target file!';
$MOD_IMAGEGALLERY_WORDS['4'] = 'Unsupported source file format!';
$MOD_IMAGEGALLERY_WORDS['5'] = 'Unsupported target file format!';
$MOD_IMAGEGALLERY_WORDS['6'] = 'GD library version does not support target file format!';
$MOD_IMAGEGALLERY_WORDS['7'] = 'GD library is not installed!';
$MOD_IMAGEGALLERY_WORDS['8'] = '"chmod" command is disabled via configuration!';
$MOD_IMAGEGALLERY_WORDS['9'] = 'exif_read_data" function is not available';

$MOD_IMAGE_METHODE['ZEBRA_IMAGE_BOXED'] = 0;
$MOD_IMAGE_METHODE['ZEBRA_IMAGE_NOT_BOXED'] = 1;
$MOD_IMAGE_METHODE['ZEBRA_IMAGE_CROP_TOPLEFT'] = 2;
$MOD_IMAGE_METHODE['ZEBRA_IMAGE_CROP_TOPCENTER'] = 3;
$MOD_IMAGE_METHODE['ZEBRA_IMAGE_CROP_TOPRIGHT'] = 4;
$MOD_IMAGE_METHODE['ZEBRA_IMAGE_CROP_MIDDLELEFT'] = 5;
$MOD_IMAGE_METHODE['ZEBRA_IMAGE_CROP_CENTER'] = 6;
$MOD_IMAGE_METHODE['ZEBRA_IMAGE_CROP_MIDDLERIGHT'] = 7;
$MOD_IMAGE_METHODE['ZEBRA_IMAGE_CROP_BOTTOMLEFT'] = 8;
$MOD_IMAGE_METHODE['ZEBRA_IMAGE_CROP_BOTTOMCENTER'] = 9;
$MOD_IMAGE_METHODE['ZEBRA_IMAGE_CROP_BOTTOMRIGHT'] = 10;


$MOD_LANG_METHODE[0]  = 'Zebra Image Boxed';
$MOD_LANG_METHODE[1]  = 'Zebra Image Not Boxed';
$MOD_LANG_METHODE[2]  = 'Zebra Image Crop Topleft';
$MOD_LANG_METHODE[3]  = 'Zebra Image Crop Topcenter';
$MOD_LANG_METHODE[4]  = 'Zebra Image Crop Topright';
$MOD_LANG_METHODE[5]  = 'Zebra Image Crop Middleleft';
$MOD_LANG_METHODE[6]  = 'Zebra Image Crop Center';
$MOD_LANG_METHODE[7]  = 'Zebra Image Crop Middleright';
$MOD_LANG_METHODE[8]  = 'Zebra Image Crop Bottomleft';
$MOD_LANG_METHODE[9]  = 'Zebra Image Crop Bottomcenter';
$MOD_LANG_METHODE[10] = 'Zebra Image Crop Bottomright';

