<?php
/**
 *
 * @category        modules
 * @package         imagegallery
 * @author          Daniel Wacker, Matthias Gallas, Rob Smith, Manfred Fuenkner
 * @copyright       2004-2009, Ryan Djurovich
 * @copyright       2009-2010, Website Baker Org. e.V.
 * @link            https://websitebaker.org/
 * @license         https://www.gnu.org/licenses/gpl.html
 * @platform        WebsiteBaker 2.13.x
 * @requirements    PHP 8.0.0 and higher
 *
 */

/* -------------------------------------------------------- */
// Must include code to stop this file being accessed directly
  if (!\defined('SYSTEM_RUN')) {\header($_SERVER['SERVER_PROTOCOL'].' 404 Not Found'); echo '404 Not Found'; \flush(); exit;}
/* -------------------------------------------------------- */

$sAddonFile   = str_replace('\\','/',__FILE__).'';
$sAddonPath   = (dirname($sAddonFile)).'/';
$sModulesPath = \dirname($sAddonPath).'/';
$sModuleName  = basename($sModulesPath);
$sAddonName   = basename($sAddonPath);
$ModuleRel    = ''.$sModuleName.'/';
$sAddonRel    = ''.$sModuleName.'/'.$sAddonName.'/';
$sPattern     = "/^(.*?\/)".$sModuleName."\/.*$/";
$sAppPath     = preg_replace ($sPattern, "$1", $sModulesPath, 1 );
//      if (!defined('SYSTEM_RUN')) {require($sAppPath.'config.php');}
$sAddonUrl    = WB_URL.'/'.$sAddonRel;
// include core functions of WB 2.7 to edit the optional module CSS files (frontend.css, backend.css)
//@include_once(WB_PATH .'/framework/module.functions.php');

// check if module language file exists for the language set by the user (e.g. DE, EN)
if (!file_exists(WB_PATH .'/modules/imagegallery/languages/'.LANGUAGE .'.php')) {
    // no module language file exists for the language set by the user, include default module language file EN.php
    require_once(WB_PATH .'/modules/imagegallery/languages/EN.php');
} else {
    // a module language file exists for the language defined by the user, load it
    require_once(WB_PATH .'/modules/imagegallery/languages/'.LANGUAGE .'.php');
}
/*
// check if backend.css file needs to be included into the <body></body> of modify.php
if(!method_exists($admin, 'register_backend_modfiles') && file_exists(WB_PATH ."/modules/imagegallery/backend.css")) {
    echo '<style type="text/css">';
    include(WB_PATH .'/modules/imagegallery/backend.css');
    echo "\n</style>\n";
}
*/

// Get settings
$sCountSql = '
SELECT COUNT(*) FROM `'.TABLE_PREFIX.'mod_imagegallery_settings`
WHERE `section_id` = '.(int)$section_id.'
';

$sSql = '
SELECT * FROM `'.TABLE_PREFIX.'mod_imagegallery_settings`
WHERE `section_id` = '.(int)$section_id.'
';

if (!$database->get_one($sCountSql)){
    include ($sAddonPath.'add.php');
}

$query_settings = $database->query($sSql);

$settings = $query_settings->fetchAssoc();

?>
<h2><?php echo $MOD_IMAGEGALLERY['MAIN_SETTINGS']; ?></h2>
<?php
// include the button to edit the optional module CSS files
// Note: CSS styles for the button are defined in backend.css (div class="mod_moduledirectory_edit_css")
// Place this call outside of any <form></form> construct!!!
    if (function_exists('edit_module_css')) {
        edit_module_css('imagegallery');
    }
?>
<div class="gallery_box">
<form name="modify" action="<?php echo WB_URL; ?>/modules/imagegallery/save.php" method="post" >
<input type="hidden" name="section_id" value="<?php echo $section_id; ?>" />
<input type="hidden" name="page_id" value="<?php echo $page_id; ?>" />

<fieldset class="gallery">
    <legend><?php echo $MOD_IMAGEGALLERY['TITLE']; ?></legend>

    <div class="gallery_setting_name"><?php echo $MOD_IMAGEGALLERY['TITLE_TEXT']; ?>:<br /></div>
    <div class="gallery_setting_value"><input type="text" name="titletext" value="<?php echo $settings['titletext']; ?>" style="width: 600px;" /><br /></div>

    <div class="gallery_setting_name"><?php echo $MOD_IMAGEGALLERY['TEXT_COLOR']; ?>:<br /></div>
    <div class="gallery_setting_value"><input class="coloris" type="text" name="fg_color" value="<?php echo $settings['fg_color']; ?>" /></div>

    <div class="gallery_setting_name"><?php echo $MOD_IMAGEGALLERY['TEXT_COLOR_HOVER']; ?>:<br /></div>
    <div class="gallery_setting_value"><input class="coloris" type="text" name="fg_hover" value="<?php echo $settings['fg_hover']; ?>" /></div>

    <div class="gallery_setting_name"><?php echo $MOD_IMAGEGALLERY['SHOW_TITLE']; ?>:<br /></div>
    <div class="gallery_setting_value checkbox"><?php if ($settings['title'] == '1') {$checked = 'checked';} else {$checked = '';}?>
    <input type="checkbox" value="1" name="title" <?php echo $checked; ?> /><br />
    </div>

</fieldset>

<fieldset class="gallery">
    <legend><?php echo $MOD_IMAGEGALLERY['ORIGINAL_PICS']; ?></legend>
<?php
        $folder_list = directory_list(WB_PATH.MEDIA_DIRECTORY);
         array_unshift($folder_list,WB_PATH.MEDIA_DIRECTORY);
//        sort($folder_list);
        $sDisallowSubdirs = ($settings['disallow_subdirs']);
        $sDisallowSubdirs = (empty($sDisallowSubdirs) ? 'thumbs' : $sDisallowSubdirs);
        $settings['disallow_subdirs']= $sDisallowSubdirs;
        $sDisllowSubdirs  = str_replace(',','|',$sDisallowSubdirs);

?>
    <div class="gallery_setting_name"><?php echo $MOD_IMAGEGALLERY['PICDIR']; ?>:<br /></div>
    <div class="gallery_setting_value select-wrapper fa fa-angle-down">
        <select class="select" name="picdir">

<?php
//        echo"<pre>";print_r($folder_list);echo"</pre>";
        foreach($folder_list as $foldername) {
            $sFolderName = str_replace(WB_PATH,'',$foldername);
            if (preg_match ('/'. $sDisllowSubdirs.'/i',$foldername)){ continue;}
            $thumb_count = substr_count($sFolderName, $settings['thumbdir']);
            if (($thumb_count==0) &&!empty(trim($foldername))){
                $sSelected = (($settings['picdir'] == $sFolderName) ? ' selected="selected"' : '' );
                $sDefault  = (($settings['picdir'] == $sFolderName) ? 'w3-default' : '');
?>
                <option title="<?=$sFolderName;?>" value="<?= $sFolderName;?>"<?=$sSelected;?> class="<?=$sDefault;?>" ><?= ($sFolderName);?></option>
<?php
            }

        }
?>
        </select>
    </div>

    <div class="gallery_setting_name" style="clear: both;"><?php echo $MOD_IMAGEGALLERY['INCLUDE_SUBDIRS']; ?>:</div>
    <div class="gallery_setting_value checkbox">
    <?php if ($settings['subdirs'] == '1') {$checked = 'checked';} else {$checked = '';}?>
    <input type="checkbox" value="1" name="subdirs" <?php echo $checked; ?> />
    </div>
    <div class="gallery_setting_name"><?php echo $MOD_IMAGEGALLERY['EXCLUDE_SUBDIRS']; ?>:</div>
    <div class="gallery_setting_value"><input type="text" value="<?= ($settings['disallow_subdirs']); ?>" name="disallow_subdirs" style="width: 600px;" /></div>

</fieldset>
<fieldset class="gallery">
    <legend><?php echo $MOD_IMAGEGALLERY['THUMBS']; ?></legend>

    <div class="gallery_setting_name"><?php echo $MOD_IMAGEGALLERY['THUMBDIR']; ?>:<br /></div>
    <div class="gallery_setting_value"><input type="text" name="thumbdir" value="<?php echo $settings['thumbdir']; ?>" /></div>

    <div class="gallery_setting_name"><?php echo $MOD_IMAGEGALLERY['THUMBS_BACKGROUND']; ?>:<br /></div>
    <div class="gallery_setting_value"><input class="coloris" type="text" name="bg_color" value="<?php echo $settings['bg_color']; ?>" /></div>

    <div class="gallery_setting_name"><?php echo $MOD_IMAGEGALLERY['MAXPICS']; ?>:<br /></div>
    <div class="gallery_setting_value"><input type="text" name="maxpics" value="<?php echo $settings['maxpics']; ?>" /></div>

    <div class="gallery_setting_name"><?php echo $MOD_IMAGEGALLERY['THUMBSIZE']; ?>:<br /></div>
    <div class="gallery_setting_value"><input type="text" name="thumbsize" value="<?php echo $settings['thumbsize']; ?>" /> px</div>

    <div class="gallery_setting_name">
    <?php echo $MOD_IMAGEGALLERY['THUMBSQUARE']; ?>:
    </div>
    <div class="gallery_setting_value select-wrapper fa fa-angle-down">
        <select class="select" name="thumbsquare">
<?PHP
        foreach($MOD_LANG_METHODE as $iValue=>$sLang) {
            $sSelected = (($settings['thumbsquare'] == $iValue) ? ' selected="selected"' : '' );
            $sDefault  = (($settings['thumbsquare'] == $iValue) ? 'w3-default' : '');
?>
          <option value="<?=$iValue;?>"<?=$sSelected;?> class="<?=$sDefault;?> w3-hover-blue" ><?=$sLang;?></option>
<?php
       }
?>
        </select>
    </div>

    <div class="gallery_setting_name" style="clear: both;"><?php echo $MOD_IMAGEGALLERY['THUMB_NEW']; ?>:<br /></div>
    <div class="gallery_setting_value checkbox"><input type="checkbox" value="1" name="thumb_new" /></div>

</fieldset>
<fieldset class="gallery">
    <legend><?php echo $MOD_IMAGEGALLERY['GALLERY']; ?></legend>

    <div class="gallery_setting_name"><?php echo $MOD_IMAGEGALLERY['MAXWIDTH']; ?>:<br /></div>
    <div class="gallery_setting_value"><input type="text" name="maxwidth" value="<?php echo $settings['maxwidth']; ?>" /> px<br /></div>

    <div class="gallery_setting_name"><?php echo $MOD_IMAGEGALLERY['INLINE']; ?>:<br /></div>
    <div class="gallery_setting_value checkbox"><?php if ($settings['inline'] == '1') {$checked = 'checked';} else {$checked = '';}?><input type="checkbox" value="1" name="inline" <?php echo $checked; ?> /><br /></div>

    <div class="gallery_setting_name"><?php echo $MOD_IMAGEGALLERY['SHOW_FILE_NAMES']; ?>:<br /></div>
    <div class="gallery_setting_value checkbox"><?php if ($settings['filenames'] == '1') {$checked = 'checked';} else {$checked = '';}?><input type="checkbox" value="1" name="filenames" <?php echo $checked; ?> /><br /></div>

    <div class="gallery_setting_name"><?php echo $MOD_IMAGEGALLERY['SHOW_ORIGINAL']; ?>:<br /></div>
    <div class="gallery_setting_value checkbox"><?php if ($settings['showoriginal'] == '1') {$checked = 'checked';} else {$checked = '';}?><input type="checkbox" value="1" name="showoriginal" <?php echo $checked; ?> /><br /></div>

    <div class="gallery_setting_name"><?php echo $MOD_IMAGEGALLERY['SHOW_TEXTLINK']; ?>:<br /></div>
    <div class="gallery_setting_value checkbox"><?php if ($settings['textlink'] == '1') {$checked = 'checked';} else {$checked = '';}?><input type="checkbox" value="1" name="textlink" <?php echo $checked; ?> /><br /></div>
</fieldset>

<table cellpadding="0" cellspacing="0" border="0" width="100%">
    <tr>
        <td align="left">
            <input name="save" type="submit" value="<?php echo $TEXT['SAVE']; ?>" style="width: 100px; margin-top: 5px;" />
        </td>
        <td align="right">
            <input type="button" value="<?php echo $TEXT['CANCEL']; ?>" onclick="window.location='<?php echo ADMIN_URL; ?>/pages/index.php'; return false;" style="width: 100px; margin-top: 5px;" />
        </td>
    </tr>
</table>
</form>
</div>
<script type="text/javascript" src="<?= WB_URL; ?>/include/plugins/default/Coloris-0.14.0/dist/coloris.min.js"></script>
    <script type="text/javascript">

    Coloris({
      el: '.coloris',
      swatches: [
        '#264653',
        '#2a9d8f',
        '#e9c46a',
        '#f4a261',
        '#e76f51',
        '#d62828',
        '#023e8a',
        '#0077b6',
        '#0096c7',
        '#00b4d8',
        '#48cae4'
      ]
    });

    </script>
