<?php
/**
 *
 * @category        modules
 * @package         imagegallery
 * @author          Daniel Wacker, Matthias Gallas, Rob Smith, Manfred Fuenkner
 * @copyright       2004-2009, Ryan Djurovich
 * @copyright       2009-2010, Website Baker Org. e.V.
 * @link            https://websitebaker.org/
 * @license         https://www.gnu.org/licenses/gpl.html
 * @platform        WebsiteBaker 2.13.x
 * @requirements    PHP 8.0.0 and higher
 *
 */
declare(strict_types=1);

use bin\{WbAdaptor,SecureTokens,Sanitize,Requester};
use bin\helpers\{PreCheck,msgQueue};

    $sAddonFile   = \str_replace('\\','/',__FILE__);
    $sFolder      = \basename(\dirname($sAddonFile));
    switch ($sFolder):
        case 'cmd':
          $sAddonPath   = \dirname($sAddonFile,2).'/';
          break;
        default :
          $sAddonPath   = (\dirname($sAddonFile)).'/';
    endswitch;

    $sModulesPath = \dirname($sAddonPath).'/';
    $sModuleName  = \basename($sModulesPath);
    $sAddonName   = \basename($sAddonPath);
    $ModuleRel    = ''.$sModuleName.'/';
    $sAddonRel    = ''.$sModuleName.'/'.$sAddonName.'/';
    $sPattern     = "/^(.*?\/)".$sModuleName."\/.*$/";
    $sAppPath     = \preg_replace ($sPattern, "$1", $sModulesPath, 1 );
    if (! \defined('SYSTEM_RUN') && \is_readable($sAppPath.'config.php')) {
        require($sAppPath.'config.php');
    }

// Tells script to update when this page was last updated
    $update_when_modified = true;
    require($sModulesPath.'admin.php');
/* -------------------------------------------------------- */
// settings needs a admin object
    $oReg      = WbAdaptor::getInstance();
    $oDb       = $oReg->getDatabase();
    $oTrans    = $oReg->getTranslate();
    $oRequest  = $oReg->getRequester();
    $oApp      = $oReg->getApplication();
    $isAuth    = $oApp->is_authenticated();
    $sAddonUrl = $oReg->AppUrl.''.$sAddonRel;
    $MediaRel  = trim($oReg->MediaDir,'/'); //

    //$sAddonUrl    = WB_URL.'/'.$sAddonRel;
    $sSectionIdPrefix = (defined('SEC_ANCHOR') && !empty(SEC_ANCHOR) ? SEC_ANCHOR : 'Sec' );
    $js_back = $oReg->AcpUrl.'pages/modify.php?page_id='.(int)$page_id;

//Get settings
    if (isset($aRequestVars['maxpics'])) {
        $maxpics = (int)$aRequestVars['maxpics'];
    } else {
        $maxpics = '9';
    }
    if (isset($aRequestVars['thumbdir'])) {
        $thumbdir = $aRequestVars['thumbdir'];
    } else {
        $thumbdir = 'thumbs';
    }
    if (isset($aRequestVars['thumbsize'])) {
        $thumbsize = (int)$aRequestVars['thumbsize'];
    } else {
        $thumbsize = '150';
    }
    if (isset($aRequestVars['filenames'])) {
        $filenames = $aRequestVars['filenames'];
    } else {
        $filenames = '0';
    }
    if (isset($aRequestVars['subdirs'])) {
        $subdirs = (int)$aRequestVars['subdirs'];
    } else {
        $subdirs = '0';
    }
    if (isset($aRequestVars['disallow_subdirs'])) {
        $sDisallowSubdirs = ($aRequestVars['disallow_subdirs']);
    } else {
        $sDisallowSubdirs = 'thumbs,data,fg-thumbs,chunks,uploads';
    }
    $sDisallowSubdirs = (empty($sDisallowSubdirs) ? 'thumbs' : $sDisallowSubdirs);

    if (isset($aRequestVars['title'])) {
        $title = (int)$aRequestVars['title'];
    } else {
        $title = '0';
    }
    if (isset($aRequestVars['maxwidth'])) {
        $maxwidth = (int)$aRequestVars['maxwidth'];
    } else {
        $maxwidth = '680';
    }
    if (isset($aRequestVars['showoriginal'])) {
        $showoriginal = (int)$aRequestVars['showoriginal'];
    } else {
        $showoriginal = 0;
    }
    if (isset($aRequestVars['textlink'])) {
        $textlink = (int)$aRequestVars['textlink'];
    } else {
        $textlink = 0;
    }
    if (isset($aRequestVars['picdir'])) {
        //$picdir = str_replace(WB_PATH,'',$aRequestVars['picdir']);
        $picdir = (str_replace($MediaRel,'',$aRequestVars['picdir']));

    } else {
        $picdir = '';
    }
    if (isset($aRequestVars['bg_color'])) {
        $bg_color = $aRequestVars['bg_color'];
    } else {
        $bg_color = '#000000';
    }
    if (isset($aRequestVars['fg_color'])) {
        $fg_color = $aRequestVars['fg_color'];
    } else {
        $fg_color = '#ffffff';
    }

    if (isset($aRequestVars['fg_hover'])) {
        $fg_hover = $aRequestVars['fg_hover'];
    } else {
        $fg_hover = '#0000ff';
    }

    if (isset($aRequestVars['titletext'])) {
        $titletext = $aRequestVars['titletext'];
    } else {
        $titletext = 'Image Gallery';
    }
    if (isset($aRequestVars['inline'])) {
        $inline = $aRequestVars['inline'];
    } else {
        $inline = 0;
    }
    if (isset($aRequestVars['thumbsquare'])) {
        $thumbsquare = $aRequestVars['thumbsquare'];
    } else {
        $thumbsquare = 6;
    }

    if (isset($aRequestVars['thumb_new']) && ($aRequestVars['thumb_new']==1)) {

          if ($subdirs==1){
              $sSubdirsPattern = str_replace(',','|',$sDisallowSubdirs);
              $aDirname = [];
              $realdir  = WB_PATH.MEDIA_DIRECTORY.$picdir;
              if (is_readable($realdir)){
                  $oIterator = PreCheck::_scanDirTreeIterator($realdir);
                  foreach($oIterator as $aFileInfo){
                      if ($aFileInfo->isDir()){$aDirname[] = $aFileInfo->getPathname();}
                  }
              }
              else
              {
                  echo \nl2br(\sprintf("---- [%04d] %s not exists \n",__LINE__,$realdir));
                  exit();
              }
              if (is_array($aDirname) && (sizeof($aDirname) > 0))
              {
                  $aDirname = array_unique($aDirname,\SORT_REGULAR );
                  foreach ($aDirname as $sThumbDir)
                  {
                      if (preg_match('/'.$sSubdirsPattern.'/i', $sThumbDir)){
                          $sSubDir = $thumbdir.'_'.$section_id;
                          if (stripos($sThumbDir,$sSubDir) && is_writeable($sThumbDir)){
                              if (!rm_full_dir($sThumbDir)){
                                echo \nl2br(\sprintf("---- [%04d] could not delete %s \n",__LINE__,$sThumbDir.'_'.$section_id));
                              }
                          }
                      }
                  }
              }

          }
          else {
          $sThumbDir = str_replace('\\','/',WB_PATH.MEDIA_DIRECTORY.$picdir.'/'.$thumbdir.'_'.$section_id.'/');
          if (is_dir($sThumbDir)) {
            //echo \nl2br(\sprintf("---- [%04d] %s \n",__LINE__,$sThumbDir));
            rm_full_dir($sThumbDir);
            }

          }
    }


//Write to database
$query = '
UPDATE `'.TABLE_PREFIX.'mod_imagegallery_settings` SET
`maxpics` = '.(int)$maxpics.',
`thumbdir` = \''.$database->escapeString($thumbdir).'\',
`thumbsize` = '.(int)$thumbsize.',
`filenames` = '.(int)$filenames.',
`subdirs` = '.(int)$subdirs.',
`disallow_subdirs` = \''.$database->escapeString($sDisallowSubdirs).'\',
`title` = '.(int)$title.',
`picdir` = \''.$database->escapeString($picdir).'\',
`bg_color` = \''.$database->escapeString($bg_color).'\',
`fg_color` = \''.$database->escapeString($fg_color).'\',
`fg_hover` = \''.$database->escapeString($fg_hover).'\',
`maxwidth` = '.(int)$maxwidth.',
`showoriginal` = '.(int)$showoriginal.',
`textlink` = '.(int)$textlink.',
`titletext` = \''.$database->escapeString($titletext).'\',
`inline` = '.(int)$inline.',
`thumbsquare` = '.(int)$thumbsquare.'
WHERE `section_id` = '.(int)$section_id.'
';

  if ($database->query($query)){
      if (is_writeable($sAddonPath.'frontend.css')){
          $aContent = file($sAddonPath.'frontend.css',\FILE_SKIP_EMPTY_LINES|\FILE_IGNORE_NEW_LINES);
          $i=0;
          for ($i; $i < count($aContent); $i++){
              $aMatches = [];
              $sItem = $aContent[$i];
              $aItem = explode(':',$sItem);
              switch (trim($aItem[0])):
                  case '--bg_color':
                    $aContent[1] = str_replace($aItem[1],$bg_color ,$sItem.";");
                    break;
                  case '--fg_color':
                    $aContent[2] = str_replace($aItem[1],$fg_color ,$sItem.";");
                    break;
                  case '--color-link':
                    $aContent[3] = str_replace($aItem[1],$fg_color ,$sItem.";");
                    break;
                  case '--color-hover':
                    $aContent[4] = str_replace($aItem[1],$fg_hover ,$sItem.";");
                    break;
                  default:
              endswitch;
              if ($aContent[$i]=='}'){break;}
          }
          $sContent = implode("\n",$aContent);
          if (file_put_contents($sAddonPath.'frontend.css',$sContent."\n",\LOCK_EX) ){}
      }
  }


// Check if there is a database error, otherwise say successful
if($database->is_error()) {
    $admin->print_error($database->get_error(), $js_back);
} else {
    $admin->print_success($MESSAGE['PAGES_SAVED'], ADMIN_URL.'/pages/modify.php?page_id='.$page_id);
}

// Print admin footer
$admin->print_footer();

