<?php
/**
 *
 * @category        modules
 * @package         imagegallery
 * @author          Daniel Wacker, Matthias Gallas, Rob Smith, Manfred Fuenkner
 * @copyright       2004-2009, Ryan Djurovich
 * @copyright       2009-2010, Website Baker Org. e.V.
 * @link            https://websitebaker.org/
 * @license         https://www.gnu.org/licenses/gpl.html
 * @platform        WebsiteBaker 2.13.x
 * @requirements    PHP 8.0.0 and higher
 *
 */

declare(strict_types=1);

use bin\{WbAdaptor,SecureTokens,Sanitize,Requester};
use bin\helpers\{PreCheck,msgQueue};

/* -------------------------------------------------------- */
// Must include code to stop this file being accessed directly
  if (!\defined('SYSTEM_RUN')) {\header($_SERVER['SERVER_PROTOCOL'].' 404 Not Found'); echo '404 Not Found'; \flush(); exit;}
/* -------------------------------------------------------- */

    $sTable = TABLE_PREFIX."mod_imagegallery_settings";
    if ($database->field_add($sTable,'titletext','TEXT NOT NULL ')){}
    if ($database->field_add($sTable,'inline','INT NOT NULL DEFAULT \'1\'')){}
    if ($database->field_modify($sTable,'thumbsquare','INT NOT NULL DEFAULT \'6\' AFTER `subdirs`')){}
    if ($database->field_add($sTable,'disallow_subdirs','TEXT NOT NULL AFTER `subdirs`')){}
    if (!$database->field_exists($sTable, 'bg') && !$database->field_exists($sTable, 'bg_color') ) {
        $database->field_add($sTable,'bg','TEXT NOT NULL AFTER `picdir`');
    }
    if ($database->renameField($sTable,'bg','bg_color','TEXT NOT NULL AFTER `picdir`')){}
    if ($database->field_add($sTable,'fg_color','TEXT NOT NULL AFTER `bg_color`')){}
    if ($database->field_add($sTable,'fg_hover','TEXT NOT NULL AFTER `fg_color`')){}

    $sAlpha = '00';
    $sField = 'bg_color';
    $sql = 'UPDATE `'.$sTable.'` SET '
     . '`'.$sField.'`=REGEXP_SUBSTR(CONCAT(\'#\', LOWER(`'.$sField.'`),\''.$sAlpha.'\'), \'#[0-9a-f]{8}\')';
// remove all thumbs folder in given picdirs
    $sDisallowSubdirs ='thumbs,data,chunks,uploads';
    $sSubdirsPattern = str_replace(',','|',$sDisallowSubdirs);
    $sSqlPicDirs  = 'SELECT `picdir` FROM '
                  . ' `'.$sTable.'` ';
    $oPicdir = $database->query($sSqlPicDirs);
    while (($img = $oPicdir->fetchAssoc())!=null) {
        $aDirname = [];
        $realdir  = WB_PATH.MEDIA_DIRECTORY.''.$img['picdir'];
        if (is_readable($realdir)){
            $oIterator = PreCheck::_scanDirTreeIterator($realdir);
            foreach($oIterator as $aFileInfo){
                if ($aFileInfo->isDir()){$aDirname[] = $aFileInfo->getPathname();}
            }
        }
        else
        {
            echo \nl2br(\sprintf("---- [%04d] %s not exists \n",__LINE__,$realdir));
            exit();
        }
        if (is_array($aDirname) && (sizeof($aDirname) > 0))
        {
            $aDirname = array_unique($aDirname,\SORT_REGULAR );
            foreach ($aDirname as $sThumbDir)
            {
                if (preg_match('/'.$sSubdirsPattern.'/i', $sThumbDir)){
                    if (!rm_full_dir($sThumbDir)){
                      echo \nl2br(\sprintf("---- [%04d] could not delete %s \n",__LINE__,$sThumbDir.'_'.$section_id));
                    }
                }
            }
        }
    }
