<?php
/**
 *
 * @category        modules
 * @package         imagegallery
 * @author          Daniel Wacker, Matthias Gallas, Rob Smith, Manfred Fuenkner
 * @copyright       2004-2009, Ryan Djurovich
 * @copyright       2009-2010, Website Baker Org. e.V.
 * @link            http://www.websitebaker2.org/
 * @license         http://www.gnu.org/licenses/gpl.html
 * @platform        WebsiteBaker 2.8.x
 * @requirements    PHP 8.0.0 and higher
 *
 */
declare(strict_types=1);

use bin\{WbAdaptor,SecureTokens,Sanitize,Requester};
use bin\helpers\{PreCheck,msgQueue};

/* -------------------------------------------------------- */
// Must include code to stop this file being accessed directly
  if (!\defined('SYSTEM_RUN')) {\header($_SERVER['SERVER_PROTOCOL'].' 404 Not Found'); echo '404 Not Found'; \flush(); exit;}
/* -------------------------------------------------------- */
    $sAddonFile   = str_replace('\\','/',__FILE__).'';
    $sAddonPath   = (dirname($sAddonFile)).'/';
    $sModulesPath = \dirname($sAddonPath).'/';
    $sModuleName  = basename($sModulesPath);
    $sAddonName   = basename($sAddonPath);
    $ModuleRel    = ''.$sModuleName.'/';
    $sAddonRel    = ''.$sModuleName.'/'.$sAddonName.'/';
    $sPattern     = "/^(.*?\/)".$sModuleName."\/.*$/";
    $sAppPath     = preg_replace ($sPattern, "$1", $sModulesPath, 1 );
    //      if (!defined('SYSTEM_RUN')) {require($sAppPath.'config.php');}
/* -------------------------------------------------------- */
// settings needs a admin object
    $oReg      = WbAdaptor::getInstance();
    $oDb       = $oReg->getDatabase();
    $oTrans    = $oReg->getTranslate();
    $oRequest  = $oReg->getRequester();
    $oApp      = $oReg->getApplication();
    $isAuth    = $oApp->is_authenticated();
    $sAddonUrl = $oReg->AppUrl.''.$sAddonRel;
    $MediaRel  = trim($oReg->MediaDir,'/'); //

// load module language file
    if (is_readable($sAddonPath.'languages/EN.php')) {require($sAddonPath.'languages/EN.php');}
    if (is_readable($sAddonPath.'languages/'.DEFAULT_LANGUAGE.'.php')) {require($sAddonPath.'languages/'.DEFAULT_LANGUAGE.'.php');}
    if (is_readable($sAddonPath.'languages/'.LANGUAGE.'.php')) {require($sAddonPath.'languages/'.LANGUAGE.'.php');}

/* -------------------------------------------------------- */
    $sCallingScript = $oRequest->getServerVar('SCRIPT_NAME');
    $ModuleUrl      = $oReg->AppUrl.$ModuleRel;
    $sAddonUrl      = $oReg->AppUrl.$sAddonRel;
    $sDomain        = $oApp->getDirNamespace(__DIR__);
    $oTrans->enableAddon($sDomain);
    $aLang          = $oTrans->getLangArray();//not needed with twig
    //$sTargetPath    = $sAddonPath.'/data/layouts/';
/* -------------------------------------------------------- */

/* obsolte since 2.8.0
// check if frontend.css file needs to be included into the <body></body> of view.php
if((!function_exists('register_frontend_modfiles') || !defined('MOD_FRONTEND_CSS_REGISTERED')) &&  file_exists(WB_PATH .'/modules/imagegallery/frontend.css')) {
   echo '<style type="text/css">';
   include(WB_PATH .'/modules/imagegallery/frontend.css');
   echo "\n</style>\n";
}
*/
// Get settings
  $sSql = '
    SELECT * FROM `'.TABLE_PREFIX.'mod_imagegallery_settings`
    WHERE `section_id` = '.(int)$section_id.'
    ';
    $query_settings = $database->query($sSql);
    $settings = $query_settings->fetchAssoc();

    $charset = DEFAULT_CHARSET;
    $maxpics = $settings['maxpics'];
    $thumbdir = $settings['thumbdir'].'_'.$section_id;
    $thumbsize = $settings['thumbsize'];
    $filenames = $settings['filenames'];
    $subdirs = $settings['subdirs'];
    $sDisallowSubdirs = $settings['disallow_subdirs'];
    $title = $settings['title'];
    $picdir = (str_replace($MediaRel,'',$settings['picdir']));

    $maxwidth = $settings['maxwidth'];
    $showoriginal = $settings['showoriginal'];
    $textlink = $settings['textlink'];
    $included = true;
    $titletext = $settings['titletext'];
    $inline = $settings['inline'];
    $thumbsquare = (int)$settings['thumbsquare'];
    $bg_color = $settings['bg_color'];
    $fg_color = $settings['fg_color'];

    if (function_exists('ini_set')) {
        \ini_set('memory_limit', '256M');
        ini_set( 'arg_separator.output' , '&amp;' );
    }

    if(!function_exists('word')){
        function word ($word) {
            global $MOD_IMAGEGALLERY_WORDS;
            $words = $MOD_IMAGEGALLERY_WORDS;
            return html($words[$word]);
        }
    }
    if(!function_exists('html')){
        function html ($word) {
            global $MOD_IMAGEGALLERY_WORDS;
            $words = $MOD_IMAGEGALLERY_WORDS;
            //return htmlentities($word, ENT_COMPAT, $charset);
            return $word;
        }
    }
    if(!function_exists('error')){
        function error(string $word, string $arg) {
            global $MOD_IMAGEGALLERY_WORDS;
            $words = $MOD_IMAGEGALLERY_WORDS;
//print '<pre  class="mod-pre" style="margin-left:30px;">function <span>'.__FUNCTION__.'( '.''.' );</span>  filename: <span>'.basename(__FILE__).'</span>  line: '.__LINE__.' -> '."\n";
//print_r( WbAdaptor::getInstance()->Trans->MOD_IMAGEGALLERY_WORDS_.$word ); print '</pre>'; \flush (); //  sleep(10); die();

            return html(str_replace('%1', $arg, ($words[$word .'_error'] ?? 'Trying to access array offset on value of type null')));
        }
    }

?>
    <!-- start image gallery -->
    <div class="imagegallery" style="background-color:<?php echo $bg_color;?>;">
<?php
    $delim = '/';
    if (array_key_exists('dir'.$section_id, $_GET) && $subdirs) {
        $dir = str_replace('../', '', $_GET['dir'.$section_id]);
    } else {
        $dir = '';
    }
    $picdir = \str_replace(MEDIA_DIRECTORY, '',$picdir);
    $dirname = WB_PATH.MEDIA_DIRECTORY.$picdir.str_replace (WB_PATH.MEDIA_DIRECTORY.$picdir, '', $dir);
    $dirnamehttp = WB_URL.MEDIA_DIRECTORY.$picdir.str_replace (WB_PATH.MEDIA_DIRECTORY.$picdir, '', $dir);

    
//    $dirname = $oReg->AppPath.$MediaRel.$picdir;
//    $dirnamehttp = $oReg->AppUrl.$MediaRel.$picdir;

    $realdir = $dirname;

    if ($delim == '/') {
        $dirnamehttp = strtr($dirnamehttp, '\\', '/');
    }
    if (substr($dirnamehttp, 0, 2) == './') {
        $dirnamehttp = substr($dirnamehttp, 2);
    }
    if (empty($dirnamehttp)) {
        $dirnamehttp = '.';
    }

    $ti = ($subdirs && !empty($dirname)) ? ':'.$dirname :'';

    if (($d = @opendir($dirname)) === false) {
        $error = error('opendir', $picdir);
    }
    if (isset($error)) {
        echo '<p style="color:red;">'.$error.'</p>'."\n";
        exit;
    }

    if ($title) {
        echo '<h3 style="text-align:center;color:'.$fg_color.';">'.$titletext.'</h3>'."\n".'<hr />'."\n";
    }

    $jpg = '\.jpg$|\.jpeg$';
    $gif = '\.gif$';
    $png = '\.png$';
    $webp = '\.webp$';
    $fontsize = 2;
    $dirs = $pics = [];
    $sExtPattern = $jpg;
    if (function_exists('imagecreatefromgif')) {
        $sExtPattern .= '|'.$gif;
    }
    if (function_exists('imagecreatefrompng')) {
        $sExtPattern .= '|'.$png;
    }
    if (function_exists('imagecreatefromwebp')) {
        $sExtPattern .= '|'.$webp;
    }
    $sExtPattern .= '';
    $sSubdirsPattern = str_replace(',','|',$sDisallowSubdirs);

// Read the picture directory:
    while (($filename = readdir($d)) !== false) {
        if ($filename == $thumbdir || ($filename == '..' && $dirname == '') || ($filename != '..' && substr($filename, 0, 1) == '.')) {
            continue;
        }

        //if (preg_match('/'.$sSubdirsPattern.'/i', $thumbdir)){continue;}
        //if (!preg_match('/'.$sExtPattern.'/i', $filename)){continue;}

        $file = $dirname . $delim . $filename;
//echo \nl2br(\sprintf("---- [%04d] %s \n",__LINE__,$filename));
        if (is_dir($file)) {
            $dirs[] = $filename;
        } elseif (preg_match('/'.$sExtPattern.'/i', $file)) {
            $pics[] = $filename;
        }

    } // while
    closedir($d);
    sort($dirs);
    sort($pics);
    $urlsuffix = '';

    foreach ($_GET as $v => $r) {
        if (!in_array($v, array('dir', 'pic', 'offset'))) {
            $urlsuffix .= '&amp;'.$v.'='.urlencode($r);
        }
    }

    if ($included && $inline && array_key_exists('pic'.$section_id, $_GET)) {
        $pic = $_GET['pic'.$section_id];
        $url = (($dirname  == '') ? '?' : '?dir').$section_id.'=' . urlencode($dir) . '&amp;';

        //Show pictures
        echo '<!-- start pictures -->'."\n";
        echo '<div class="pictures">'."\n";
        list($width, $height, $type, $attr) = @getimagesize(html($dirname.'/'.$pics[$pic]));

        if (($width <= $maxwidth) && (($width != "") || ($width == 0))) {
            /* ...do something, whatever the programmer's think... */
        } else {
            $heightadjust = $maxwidth/$width;
            $width = $maxwidth;
            $height = $heightadjust*$height;
        }
        if ($showoriginal == 1) {
            echo '<a href="'.html($dirnamehttp.'/'.$pics[$pic]).'" target="_blank" rel="noopener">';
        }
        echo '<img src="'.html($dirnamehttp.'/'.$pics[$pic]).'" alt="'.html(basename($pics[$pic])).'" width="'.$width.'" height="'.$height.'" />';
        if ($showoriginal==1) {
            echo '</a>'."\n";
        } else {
            echo "\n" ;
        }
        echo '<hr />'."\n";

        //Generate previous/next section
        if ((array_key_exists('dir'.$section_id, $_GET)) || (array_key_exists('pic'.$section_id, $_GET))){
            $showarrows = 'yes';
        }
        $urlsuffix = str_replace('pic'.$section_id.'='.$pic,'',$urlsuffix);
        if ($showarrows == 'yes'){
            if ($pic > 0) {
                if ($textlink==1){
                    echo '<a href="'.html($url).'pic'.$section_id.'='.($pic-1).html($urlsuffix).'">['.$MOD_IMAGEGALLERY['PREVIOUS'].']</a>';
                } else {
                    echo '<a href="'.html($url).'pic'.$section_id.'='.($pic-1).html($urlsuffix).'" title="'.$MOD_IMAGEGALLERY['PREVIOUS'].'"><img src="'.WB_URL.'/modules/imagegallery/images/left_16.png" border="0" alt="'.$MOD_IMAGEGALLERY['PREVIOUS'].'" /></a>';
                }
            }
        }
        if ($pic >= $maxpics) {
            $u = $url.'offset='.floor($pic / $maxpics) * $maxpics.$urlsuffix;
        } else {
            if (array_key_exists('dir'.$section_id, $_GET)) {
                $u = substr($url, 0, strlen($url) - 1).$urlsuffix;
            } else {
                $u = preg_replace('/^([^?]+).*$/i', '\1', $_SERVER['REQUEST_URI']);
                if (!empty($urlsuffix)) {
                    if (strstr($u, '?') === false) {
                        $u .= '?'.substr($urlsuffix, 1);
                    } else {
                        $u .= $urlsuffix;
                    }
                }
            }
        }
        if ($showarrows == 'yes'){
            if ($textlink == 1) {
                echo '<a href="'.html($u).'">['.$MOD_IMAGEGALLERY['OVERVIEW'].']</a>';
            } else {
                echo '<a href="'.html($u).'" title="'.$MOD_IMAGEGALLERY['OVERVIEW'].'"><img src="'.WB_URL.'/modules/imagegallery/images/up_16.png" border="0" alt="'.$MOD_IMAGEGALLERY['OVERVIEW'].'" /></a>';
            }
            if ($pic + 1 < sizeof($pics)){
                if ($textlink == 1){
                        echo '<a href="'.html($url).'pic'.$section_id.'='.($pic + 1).html($urlsuffix).'">['.$MOD_IMAGEGALLERY['NEXT'].']</a>';
                } else {
                        echo '<a href="'.html($url).'pic'.$section_id.'='.($pic + 1).html($urlsuffix).'" title="'.$MOD_IMAGEGALLERY['NEXT'].'"><img src="'.WB_URL.'/modules/imagegallery/images/right_16.png" border="0" alt="'.$MOD_IMAGEGALLERY['NEXT'].'" /></a>';
                }
            }
        }
        echo "\n".'</div>'."\n";
        echo '<!-- end pictures -->'."\n";
    } else {
    // Check for Subdirectories and list them:
        if (sizeof($dirs) > 0 && $subdirs) {

            echo '<!-- start directories -->'."\n";
            echo '<ul class="directories">'."\n";

            foreach ($dirs as $filename) {
                if (preg_match('/'.$sSubdirsPattern.'/i', $filename)){continue;}

                if (isset($rp)) {
                    $target = substr(realpath($realdir.$delim.$filename), mb_strlen($root));
                } else {
                    $target = substr((string)$dir.$delim.$filename, mb_strlen(($root ?? '')));
                }
                if ($delim == '\\') {
                    $target = strtr($target, '\\', '/');
                }
                if ($target == '') {
                    $url = preg_replace('/^([^?]+).*$/i', '\1', $_SERVER['REQUEST_URI']);
                    if (!empty($urlsuffix)) {
                        if (strstr($url, '?') === false) {
                            $url .= '?' . substr($urlsuffix, 1);
                        } else {
                            $url .= $urlsuffix;
                        }
                    }
                } else {
                    $url = '?dir'.$section_id.'='.urlencode($target);
                }
                
                $predir = str_replace (WB_PATH.MEDIA_DIRECTORY.$picdir, '', $dirname);
                $target2 = str_replace($dir,'',$target);
                if ($target2 == '/..' && trim($predir) == ''){
                    /* ...do something, whatever the programmer's think... */
                } else {
                    if ($target2 == '/..'){
                        $urlsearch  = ['%2F..', '%2F', '+'];
                        $urlreplace = ['', '/', ' '];
                        $url = str_replace($urlsearch, $urlreplace, $url);
                        $urllist = explode('/', $url);
                        $urlcount = count($urllist);
                        $urlpre = $urllist[$urlcount-1];
                        $url = str_replace('/'.$urlpre, '', $url);
                    }
                    $sValue = ((html($filename)=='..') ? $MOD_IMAGEGALLERY['OVERVIEW'] : html($filename));
                    echo '<li><a class="overview" href="'.html($url).'">'.$sValue.'</a></li>'."\n";
                }
            }
            echo '</ul>'."\n";
            echo '<hr />'."\n";
            echo '<!-- end directories -->'."\n";
        }
        if (($num = sizeof($pics)) > 0) {
            if (array_key_exists('offset'.$section_id, $_GET)) {
                $offset = $_GET['offset'.$section_id];
            } else {
                $offset = 0;
            }
            if ($num > $maxpics) {
                //generate pagenumbers
                echo '<!-- start pagenumbers -->'."\n";
                echo '<div class="pagenumbers">'."\n";
                for ($i = 0; $i < $num; $i += $maxpics) {
                    $e = $i + $maxpics - 1;
                    if ($e > $num - 1) {
                        $e = $num - 1;
                    }
                    if ($i != $e) {
                        $b = ($i + 1).'-'.($e + 1);
                    } else {
                        $b = $i + 1;
                    }
                    if ($i == $offset) {
                        echo '<strong>'.$b.'</strong>';
                    } else {
                        $predir = str_replace (WB_PATH.MEDIA_DIRECTORY.$picdir, '', $dirname);
                        $url = ($dirname  == '') ? '?' : '?dir'.$section_id.'=' . urlencode($predir).'&amp;';
                        $urlsuffix = str_replace('offset'.$section_id.'='.$offset,"",$urlsuffix);
                        echo '<a href="'.$url.'offset'.$section_id.'='.$i.html($urlsuffix).'">'.$b.'</a>';
                    }
                    if ($e != $num - 1) {
                        echo ' |';
                    }
                    echo "\n" ;
                }
                echo '</div>'."\n".'<hr />'."\n";
                echo '<!-- end pagenumbers -->'."\n";
            }

        //generate preview images
            echo '<!-- start preview images -->'."\n";
            echo '<div class="pictures">'."\n";
            for ($i = $offset; $i < $offset + $maxpics; $i++) {
                if ($i >= $num) {
                    break;
                }
                $filename = $pics[$i];
                $file = $realdir . $delim . $filename;
                if (!is_readable($file)) {continue;}

                if (!is_dir($realdir . $delim . $thumbdir)) {
                    $u = umask(0);
                    if (!@mkdir($realdir . $delim . $thumbdir, 0777)) {
                        echo '<p style="color: red; text-align: center;">'.word('mkdir_error').'</p>';
                        break;
                    }
                    umask($u);
                }
                $thumb = $realdir . $delim . $thumbdir . $delim . $filename . '.thumb.jpg';

                if (!is_file($thumb)) {
/* --- TODO include old gd methode or Zebra_Image */
        $bCanContinue = true;
        require $sAddonPath.'createZebraImages.php';
/* --- TODO END include old gd methode */
            } // create thumb
            echo '<span class="picturelink">';
            if ($included && $inline) {
                echo '<a href="?';
                if (array_key_exists('dir'.$section_id, $_GET)) {
                    echo 'dir'.$section_id.'='.urlencode($_GET['dir'.$section_id]).'&amp;';
                }
                echo 'pic'.$section_id.'='.$i.html($urlsuffix).'">';
            } else {
                echo '<a href="'.html($dirnamehttp.'/'.$filename).'">';
            }
            echo '<img src="' . html($dirnamehttp.'/'.$thumbdir.'/'.$filename.'.thumb.jpg').'" alt="'.html($filename).'" width="'.$thumbsize.'" height="'.$thumbsize.'" />';
            if ($filenames) {
                echo '<br /><span class="filename">'.html($filename).'</span>';
            }
            echo '</a></span>'."\n";
            }
            echo '<span class="clear">&nbsp;</span>'."\n";
            echo '</div>'."\n";
            echo '<!-- end preview images -->'."\n";
        }
    }
echo '</div>'."\n";
echo '<!-- end image gallery -->'."\n";